# MySQL dump 8.14
#
# Host: localhost    Database: mhs
#--------------------------------------------------------
# Server version	3.23.39-log

#
# Table structure for table 'COURSEINFO'
#

CREATE TABLE COURSEINFO (
  id int(11) NOT NULL auto_increment,
  cc varchar(30) NOT NULL default '',
  schoolid varchar(16) NOT NULL default '',
  facultyname varchar(50) default NULL,
  facultycode varchar(50) default NULL,
  period varchar(8) default NULL,
  email varchar(50) default NULL,
  phone varchar(20) default NULL,
  misc varchar(80) default NULL,
  coursename varchar(50) default NULL,
  assignlist mediumtext,
  assignvals mediumtext,
  ealr mediumtext,
  modified varchar(50) default NULL,
  type char(2) default NULL,
  LastUpdate timestamp(14) NOT NULL,
  PRIMARY KEY  (id),
  KEY courseinfo_cc_index (cc),
  KEY courseinfo_schoolid_index (schoolid)
) TYPE=MyISAM;

#
# Dumping data for table 'COURSEINFO'
#

# Table structure for table 'GMSCORES'
#

CREATE TABLE GMSCORES (
  id int(11) NOT NULL auto_increment,
  sid int(11) NOT NULL default '0',
  cc varchar(30) NOT NULL default '',
  schoolid varchar(16) NOT NULL default '',
  scores mediumtext,
  percent double default NULL,
  grade varchar(50) default NULL,
  comments varchar(50) default NULL,
  LastUpdate timestamp(14) NOT NULL,
  PRIMARY KEY  (id),
  KEY gmscores_sid_index (sid),
  KEY gmscores_cc_index (cc),
  KEY gmscores_schoolid_index (schoolid)
) TYPE=MyISAM;

#
# Dumping data for table 'GMSCORES'
#

#
# Table structure for table 'SCHOOLS'
#

CREATE TABLE SCHOOLS (
  id int(11) NOT NULL auto_increment,
  school_id varchar(16) NOT NULL default '',
  school_name varchar(50) default NULL,
  school_state char(2) default NULL,
  school_city varchar(50) default NULL,
  school_url varchar(80) default NULL,
  LastUpdate timestamp(14) NOT NULL,
  PRIMARY KEY  (id),
  KEY schools_school_id_index (school_id)
) TYPE=MyISAM;

#
# Dumping data for table 'SCHOOLS'
#

INSERT INTO SCHOOLS VALUES (1,'Mead','Mead High\r\nSchool','WA','Spokane','http://www.mead.k12.wa.us/mhs/',20010807214434);

#
# Table structure for table 'calendar'
#

CREATE TABLE calendar (
  id int(11) NOT NULL auto_increment,
  username varchar(255) default NULL,
  stamp datetime default NULL,
  subject varchar(255) default NULL,
  description text,
  type varchar(254) NOT NULL default '',
  teacher varchar(254) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table 'calendar'
#

INSERT INTO calendar VALUES (36,NULL,'2001-11-20 00:00:00','Kennewick Leadership Conference(Music)','','Main','');
INSERT INTO calendar VALUES (37,NULL,'2001-11-20 19:00:00','Mr. Mead in the Theatre','','Main','');
INSERT INTO calendar VALUES (38,NULL,'2001-11-12 00:00:00','No School - Veterans Day','','Main','');
INSERT INTO calendar VALUES (35,'','2001-11-19 19:00:00','Volleyball Banquet','','Main Athletics','');
INSERT INTO calendar VALUES (33,NULL,'2001-11-19 09:00:00','Sr. Reg. (2nd Period)','','Main','');
INSERT INTO calendar VALUES (34,NULL,'2001-11-19 10:00:00','Jr. Reg. (3rd Period)','','Main','');
INSERT INTO calendar VALUES (13,'','2001-11-05 19:00:00','Jazz Band & Choir Concert','','Main Clubs','');
INSERT INTO calendar VALUES (12,'','2001-11-05 14:45:00','Gymnastics Begins','','Main Athletics','');
INSERT INTO calendar VALUES (14,NULL,'2001-11-06 09:00:00','College Fair','','Main','');
INSERT INTO calendar VALUES (15,'','2001-11-07 00:00:00','Fall Blood Drive','','Main Students','');
INSERT INTO calendar VALUES (16,NULL,'2001-11-07 00:00:00','CWMEA Jazz Festival - Whitworth','','Main','');
INSERT INTO calendar VALUES (17,NULL,'2001-11-08 00:00:00','Fall Blood Drive','','Main','');
INSERT INTO calendar VALUES (18,'','2001-11-08 18:00:00','Boys XC Awards in Mall','','Main Athletics','');
INSERT INTO calendar VALUES (19,NULL,'2001-11-09 09:15:00','Fall Rec. Assembly','','Main','');
INSERT INTO calendar VALUES (55,NULL,'2001-11-10 20:30:00','Sadie Hawkins Dance','From 9:00pm to 12:00pm. This year\\\'s Sadie Hawkins dance has the theme of \\\"A Walk Through Time\\\".','','');
INSERT INTO calendar VALUES (21,'','2001-11-10 00:00:00','Volleyball State - Arena','','Main Athletics Students','');
INSERT INTO calendar VALUES (39,NULL,'2001-11-12 00:00:00','Winter Sports  Begin','','Main','');
INSERT INTO calendar VALUES (25,'','2001-11-01 07:00:00','Varsity Football @ U-Hi','','Main Athletics','');
INSERT INTO calendar VALUES (26,'','2001-11-01 02:30:00','Frosh Football @ Rogers','','Main Athletics','');
INSERT INTO calendar VALUES (27,'','2001-11-01 00:00:00','Debate @ Whitman College','','Main Clubs','');
INSERT INTO calendar VALUES (28,'','2001-11-02 00:00:00','Volleyball @ Regionals in Tri-Cities','','Main Athletics','');
INSERT INTO calendar VALUES (29,'','2001-11-02 02:30:00','JV Football vs. U-HI @ MHS','','Main Athletics','');
INSERT INTO calendar VALUES (30,'','2001-11-02 00:00:00','Debate @ Whitman College','','Main Clubs','');
INSERT INTO calendar VALUES (31,'','2001-11-02 00:00:00','End of 1st Quarter','','Main Students','');
INSERT INTO calendar VALUES (45,NULL,'2001-11-13 00:00:00','Coast Guard in the Mall @Lunches','','Main','');
INSERT INTO calendar VALUES (46,NULL,'2001-11-15 00:00:00','Fall Play Starts','','Main','');
INSERT INTO calendar VALUES (43,NULL,'2001-11-15 00:00:00','Fall Camp @ Pinelow','','Main','');
INSERT INTO calendar VALUES (47,NULL,'2001-12-20 00:00:00','Start of Winter Break','','Main','');
INSERT INTO calendar VALUES (50,NULL,'2001-11-09 00:00:00','Debate @ Puyallup','','Main','');
INSERT INTO calendar VALUES (52,NULL,'2001-11-14 00:00:00','Report Cards','Yes, report cards will be sent out today.','','');
INSERT INTO calendar VALUES (51,NULL,'2001-11-16 00:00:00','State Soccer','Come cheer on our girls as they go after the state title!','','');
INSERT INTO calendar VALUES (53,NULL,'2001-11-03 13:30:00','State XC','The Mead boys are going to win thier 12th state title!','','');
INSERT INTO calendar VALUES (57,NULL,'2001-11-21 00:00:00','Junior Registration','Register during history classes in the mall.','','');
INSERT INTO calendar VALUES (58,NULL,'2001-11-22 00:00:00','Happy Thanksgiving!','','','');
INSERT INTO calendar VALUES (91,NULL,'2001-12-07 16:00:00','JVG Basketball @ NC','','Main  Athletics','');
INSERT INTO calendar VALUES (61,NULL,'2001-12-01 09:00:00','Mead Classic Wrestling Invite','Mead\\\'s own annual wrestling tournament that kicks off the wrestling season each year.','Main  Athletics','');
INSERT INTO calendar VALUES (62,NULL,'2001-12-01 00:00:00','Debate GSL #2 @MtS','','Main Clubs','');
INSERT INTO calendar VALUES (80,NULL,'2001-12-04 17:15:00','9th B Basketball @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (78,NULL,'2001-12-04 19:30:00','Varsity Girls Basketball @ SP','','Main  Athletics','');
INSERT INTO calendar VALUES (69,NULL,'2001-12-04 00:00:00','Navy in the Mall @ lunches','','Main','');
INSERT INTO calendar VALUES (77,NULL,'2001-12-04 17:45:00','Varsity Boys Basketball @ SP','','Main  Athletics','');
INSERT INTO calendar VALUES (76,NULL,'2001-12-04 16:00:00','JVB Basketball @ SP','','Main  Athletics','');
INSERT INTO calendar VALUES (79,NULL,'2001-12-04 15:30:00','9th G Basketball @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (81,NULL,'2001-12-04 15:30:00','JVG Basketball @ MHS','','','');
INSERT INTO calendar VALUES (82,NULL,'2001-12-04 19:00:00','CG Basketball WV','','Main  Athletics','');
INSERT INTO calendar VALUES (83,NULL,'2001-12-05 18:30:00','Gymnaastics CV/LC @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (84,NULL,'2001-12-05 17:00:00','9th and JV Wrestling @ EV','','Main  Athletics','');
INSERT INTO calendar VALUES (85,NULL,'2001-12-05 19:00:00','Varsity Wrestling @ EV','','Main  Athletics','');
INSERT INTO calendar VALUES (86,NULL,'2001-12-05 19:00:00','Financial Aide Evening @ MHS','Parents of seniors can come and seek advice on taking advantage of financial aide from universities and colleges.','Main','');
INSERT INTO calendar VALUES (87,NULL,'2001-12-06 17:00:00','9th and JV Wrestling NC @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (88,NULL,'2001-12-06 19:30:00','Varsity Wrestling NC @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (89,NULL,'2001-12-06 19:30:00','CB Basketball MtS @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (90,NULL,'2001-12-06 19:30:00','CG Basketball @ MtS','','Main  Athletics','');
INSERT INTO calendar VALUES (92,NULL,'2001-12-07 17:45:00','Varsity Girls Basketball @ NC','','Main  Athletics','');
INSERT INTO calendar VALUES (93,NULL,'2001-12-07 19:30:00','Varsity Boys Basketball @ NC','','Main  Athletics','');
INSERT INTO calendar VALUES (94,NULL,'2001-12-07 00:00:00','Wrestling Inland Empire @ CV','','Main  Athletics','');
INSERT INTO calendar VALUES (95,NULL,'2001-12-07 15:30:00','JVB Basketball NC @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (96,NULL,'2001-12-07 15:30:00','9th Boys Basketball NC @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (97,NULL,'2001-12-07 17:15:00','9th Girls Basketball NC @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (98,NULL,'2001-12-08 08:00:00','JV Wrestle-In @ EV','','Main  Athletics','');
INSERT INTO calendar VALUES (99,NULL,'2001-12-08 00:00:00','Wrestling Inland Empire @ CV','','Main  Athletics','');
INSERT INTO calendar VALUES (100,NULL,'2001-12-08 20:30:00','Holiday Dance in the Mall','','Main','');
INSERT INTO calendar VALUES (101,NULL,'2001-12-11 16:00:00','JVG Basketball CV @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (102,NULL,'2001-12-11 17:45:00','Varsity Girls Basketball CV @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (103,NULL,'2001-12-11 19:30:00','Varsity Boys Basketball CV @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (104,NULL,'2001-12-11 16:30:00','CB Basketball CV @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (105,NULL,'2001-12-11 15:00:00','CG Basketball CV @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (106,NULL,'2001-12-11 00:00:00','Army National Guard in the Mall @ lunches','','Main','');
INSERT INTO calendar VALUES (107,NULL,'2001-12-11 15:30:00','JVB Basketball @ CV','','Main  Athletics','');
INSERT INTO calendar VALUES (108,NULL,'2001-12-12 18:30:00','Gymnastics vs. Ferris/UH/SP @ SP','','Main  Athletics','');
INSERT INTO calendar VALUES (109,NULL,'2001-12-12 17:00:00','9th and JV Wrestling Ferris @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (110,NULL,'2001-12-12 19:30:00','Varsity Wrestling Ferris @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (111,NULL,'2001-12-12 19:00:00','Band Concert at the Theatre','','Main Clubs','');
INSERT INTO calendar VALUES (112,NULL,'2001-12-13 19:00:00','Egg Nog Evening in the Mall','','Main','');
INSERT INTO calendar VALUES (113,NULL,'2001-12-13 17:00:00','9th and JV Wrestling @ GP','','Main  Athletics','');
INSERT INTO calendar VALUES (114,NULL,'2001-12-13 19:30:00','Varsity Wrestling @ GP','','Main  Athletics','');
INSERT INTO calendar VALUES (115,NULL,'2001-12-13 18:00:00','CB and CG Basketball @ STG','','Main  Athletics','');
INSERT INTO calendar VALUES (116,NULL,'2001-12-14 16:00:00','JVB Basketball @ EV','','Main  Athletics','');
INSERT INTO calendar VALUES (117,NULL,'2001-12-14 17:45:00','Varsity Boys Basketball @ EV','','Main  Athletics','');
INSERT INTO calendar VALUES (118,NULL,'2001-12-14 19:30:00','Varstiy Girls Basketball @ EV','','Main  Athletics','');
INSERT INTO calendar VALUES (119,NULL,'2001-12-14 15:30:00','JVG Basketball EV @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (120,NULL,'2001-12-14 15:30:00','9th G Basketball EB @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (121,NULL,'2001-12-14 17:15:00','9th B Basketball EV @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (122,NULL,'2001-12-14 10:00:00','Wrestling Tri State @ NIC','','Main  Athletics','');
INSERT INTO calendar VALUES (123,NULL,'2001-12-14 19:30:00','CB and CG Basketball @ GP','','Main  Athletics','');
INSERT INTO calendar VALUES (124,NULL,'2001-12-15 08:30:00','Wrestling Tri-State @ NIC','','Main  Athletics','');
INSERT INTO calendar VALUES (125,NULL,'2001-12-15 00:00:00','JV Wrestling Dual Team Tournament @ Freeman','','Main  Athletics','');
INSERT INTO calendar VALUES (126,NULL,'2001-12-17 19:00:00','Choir Concert','','Main','');
INSERT INTO calendar VALUES (127,NULL,'2001-12-17 18:00:00','CB and CG Basketball @ Cheney','','Main  Athletics','');
INSERT INTO calendar VALUES (128,NULL,'2001-12-18 16:00:00','JVB Basketball Ferris @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (129,NULL,'2001-12-18 17:45:00','Varsity Boys Ferris @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (130,NULL,'2001-12-18 19:30:00','Varsity Girls Basketball Ferris @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (131,NULL,'2001-12-18 00:00:00','Marines in the Mall @ lunches','','Main','');
INSERT INTO calendar VALUES (132,NULL,'2001-12-18 15:30:00','JVG Basketball @ Ferris','','Main  Athletics','');
INSERT INTO calendar VALUES (133,NULL,'2001-12-18 17:15:00','9th G and B Basketball @ Ferris','','Main  Athletics','');
INSERT INTO calendar VALUES (134,NULL,'2001-12-19 00:00:00','Holiday Assembly','','','');
INSERT INTO calendar VALUES (135,NULL,'2001-12-19 19:00:00','CB and CG Basketball EB @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (136,NULL,'2001-12-21 17:00:00','CB and CG Basketball UH @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (137,NULL,'2001-12-21 16:00:00','JVG Basketball UH @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (138,NULL,'2001-12-21 17:45:00','Varsity Girls Basketball UH @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (139,NULL,'2001-12-21 19:30:00','Varsity Boys Basketball UH @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (140,NULL,'2001-12-21 15:30:00','JVB Basketball @ UH','','Main  Athletics','');
INSERT INTO calendar VALUES (141,NULL,'2001-12-28 16:00:00','JVB Basketball @ LC','','Main  Athletics','');
INSERT INTO calendar VALUES (142,NULL,'2001-12-28 17:45:00','Varsity Boys Basketball @ LC','','Main  Athletics','');
INSERT INTO calendar VALUES (143,NULL,'2001-12-28 19:30:00','Varsity Girls Basketball @ LC','','Main  Athletics','');
INSERT INTO calendar VALUES (144,NULL,'2001-12-28 15:30:00','JVG Basketball LC @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (145,NULL,'2001-12-28 15:30:00','9th Girls and Boys Basketball LC @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (146,NULL,'2001-12-29 10:00:00','Varsity and JV Wrestling Tri-County @ CV','','Main  Athletics','');
INSERT INTO calendar VALUES (147,NULL,'2002-01-02 00:00:00','Scool Resumes','','Main','');
INSERT INTO calendar VALUES (150,NULL,'2002-01-02 00:00:00','Wresting SP @ MHS 9/JV 5 p.m., V 7:30 p.m.','','Main  Athletics','');
INSERT INTO calendar VALUES (151,NULL,'2001-01-03 18:30:00','Gymnastics LC/NC @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (152,NULL,'2002-01-03 18:30:00','Gymnastics LC/NC @ MHS','','Main  Athletics','');
INSERT INTO calendar VALUES (153,NULL,'2002-01-03 00:00:00','Wrestling @ UH 9/JV 5 p.m. V 7:30 p.m.','','Main  Athletics','');
INSERT INTO calendar VALUES (154,NULL,'2002-01-04 00:00:00','Basketball VS. Rogers @ Arena VB 7:15 p.m., VG 9 p.m.','','Main  Athletics','');
INSERT INTO calendar VALUES (155,NULL,'2002-01-04 00:00:00','Basketball VS. Rogers @ MHS JVB 4 p.m.','','Main  Athletics','');
INSERT INTO calendar VALUES (156,NULL,'2002-01-04 00:00:00','Basketball @ Rogers 9G 5:15 p.m., 9B 7 p.m.','','Main  Athletics','');
INSERT INTO calendar VALUES (157,NULL,'2002-01-04 00:00:00','Debate @ GU','','Main Clubs','');
INSERT INTO calendar VALUES (158,NULL,'2002-01-05 00:00:00','Practice SAT @ MHS Lib. 8 a.m.','','Main','');
INSERT INTO calendar VALUES (159,NULL,'2002-01-05 00:00:00','Debate @ GU','','Main Clubs','');
INSERT INTO calendar VALUES (160,NULL,'2002-01-09 00:00:00','Gymnastics Mead/Rogers @ Lakeside 6:30 p.m.','','Main  Athletics','');
INSERT INTO calendar VALUES (161,NULL,'2002-01-09 00:00:00','Wrestling LC @ MHS 9/JV 5 p.m., V 7:30 p.m.','','Main  Athletics','');
INSERT INTO calendar VALUES (162,NULL,'2002-01-10 00:00:00','CCB Cheney @ MHS 7 p.m.','','Main','');
INSERT INTO calendar VALUES (169,NULL,'2002-01-11 00:00:00','Best MIXER ever! 8-11 p.m.','It\\\'s going to be the loudest, biggest, baddest, sexiest, mixer of all time! Experience the all new Media Box on it\\\'s maiden voyage!  ','','');
INSERT INTO calendar VALUES (164,NULL,'2002-01-07 00:00:00','CBB StG @ MHS 7 p.m.','','Main','');
INSERT INTO calendar VALUES (165,NULL,'2002-01-07 00:00:00','CCB STG @ MHS FH 7 p.m.','','Main','');
INSERT INTO calendar VALUES (166,NULL,'2002-01-08 00:00:00','ASB Elections Assembly','','Main Clubs','');
INSERT INTO calendar VALUES (167,NULL,'2002-01-08 00:00:00','Basketball @ MtS JVG 3:30 p.m., VG 5:45 p.m., VB 7:30 p.m.','','Main  Athletics','');
INSERT INTO calendar VALUES (168,NULL,'2002-01-08 00:00:00','Basketball @ MtS MHS JVB 3:30 p.m., 9thB 3:30 p.m., 9thG 5:15 p.m.','','Main  Athletics','');
INSERT INTO calendar VALUES (170,NULL,'2002-01-11 00:00:00','Wrestling Rocky Mountain @ Missoula 10 a.m.','','Main  Athletics','');
INSERT INTO calendar VALUES (171,NULL,'2002-01-12 00:00:00','Wresting Rocky Mountain @ Missoula 10 a.m.','','Main  Athletics','');
INSERT INTO calendar VALUES (172,NULL,'2002-01-12 00:00:00','9th W Invite @ NC 8 a.m.','','Main  Athletics','');
INSERT INTO calendar VALUES (173,NULL,'2002-01-12 00:00:00','Practice ACT Library 8 a.m.','','Main','');
INSERT INTO calendar VALUES (174,NULL,'2002-01-12 00:00:00','CB Basketball Oliver BC @ MHS 12:30 p.m.','','Main  Athletics','');
INSERT INTO calendar VALUES (175,NULL,'2002-01-14 00:00:00','CB Basketball @ UH 7 p.m.','','Main  Athletics','');
INSERT INTO calendar VALUES (176,NULL,'2002-01-15 00:00:00','Basketball @ GP JVB 4 p.m., VB 5:45 p.m., VG 7:30 p.m.','','Main  Athletics','');

#
# Table structure for table 'clients'
#

CREATE TABLE clients (
  id int(11) NOT NULL auto_increment,
  client_id varchar(80) NOT NULL default '',
  client_pw varchar(16) default NULL,
  client_school varchar(16) default NULL,
  client_expdate date default NULL,
  client_fullname varchar(50) default NULL,
  webinfo mediumtext,
  webinfodate date default NULL,
  LastUpdate timestamp(14) NOT NULL,
  PRIMARY KEY  (id),
  KEY client_id_index (client_id)
) TYPE=MyISAM;

#
# Dumping data for table 'clients'
#

INSERT INTO clients VALUES (1,'Test','1234','Mead','2007-04-20','Paul\r\nQuerna',NULL,NULL,20010807214837);
INSERT INTO clients VALUES (2,'teacher','1234','Mead','0000-00-00','Mr. Bassett','','0000-00-00',20010809144535);

#
# Table structure for table 'comp'
#

CREATE TABLE comp (
  id int(11) NOT NULL auto_increment,
  type varchar(254) NOT NULL default '',
  content text NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table 'comp'
#

INSERT INTO comp VALUES (1,'links','Cool Website^#^http://10.80.1.217\r\nCool Warez Website^#^http://10.80.1.217');
INSERT INTO comp VALUES (2,'text','Blah Blah Blah... this is my FreeForm Text');
INSERT INTO comp VALUES (3,'calendar','week');

#
# Table structure for table 'feedback_a'
#

CREATE TABLE feedback_a (
  id int(11) NOT NULL auto_increment,
  email varchar(254) NOT NULL default '',
  answer longtext NOT NULL,
  time bigint(20) NOT NULL default '0',
  seen char(1) NOT NULL default '0',
  qid int(11) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table 'feedback_a'
#


#
# Table structure for table 'feedback_q'
#

CREATE TABLE feedback_q (
  id int(11) NOT NULL auto_increment,
  question text NOT NULL,
  time int(11) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table 'feedback_q'
#

INSERT INTO feedback_q VALUES (5,'For the first quarter, Report cards were issued on November 14th. Did you see your Son/Daughter\'s report card?',1006278812);
INSERT INTO feedback_q VALUES (10,'Currently, quarter grades are sent home with students; would you prefer that they be sent home via the mail?',1007400919);
INSERT INTO feedback_q VALUES (11,'Is the newsletter helpful in communicating school information to your home? Or, is there information that you would like us to include that currently isn\'t a part of the newletter?',1007400950);

#
# Table structure for table 'homepage'
#

CREATE TABLE homepage (
  id int(11) NOT NULL auto_increment,
  username char(254) NOT NULL default '',
  ord int(11) NOT NULL default '0',
  compid int(11) NOT NULL default '0',
  LastUpdate timestamp(14) NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table 'homepage'
#

INSERT INTO homepage VALUES (2,'thanson',1,3,20011108101952);
INSERT INTO homepage VALUES (3,'thanson',2,2,20011108101958);
INSERT INTO homepage VALUES (4,'thanson',3,1,20011108102006);

#
# Table structure for table 'images'
#

CREATE TABLE images (
  id int(11) NOT NULL auto_increment,
  title varchar(254) default NULL,
  address text NOT NULL,
  description text NOT NULL,
  type varchar(254) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table 'images'
#

INSERT INTO images VALUES (1,'Bruce & Kevin','/home/httpd/html/images/front/front.jpg','Bruce and Kevin','Main');
INSERT INTO images VALUES (2,'Kevin and Randy','/home/httpd/html/images/front/front2.jpg','hmmmm testing...','Main');
INSERT INTO images VALUES (3,'Bruce & Kevin','/home/httpd/html/images/front/Pic3.jpg','Bruce and Kevin','Main');
INSERT INTO images VALUES (4,'Bruce & Kevin','/home/httpd/html/images/front/Pic2.jpg','Meet the cooks','Main');
INSERT INTO images VALUES (5,'Bruce & Kevin','/home/httpd/html/images/front/Pic1.jpg','Bruce and Kevin','Main');
INSERT INTO images VALUES (6,'Three Girls','/home/httpd/html/images/front/3girils.jpg','','Main Clubs Students');
INSERT INTO images VALUES (7,'Four Girls','/home/httpd/html/images/front/4girls.jpg','','Main Clubs Students');
INSERT INTO images VALUES (8,'Aubree','/home/httpd/html/images/front/aubree.jpg','','Main Clubs Students');
INSERT INTO images VALUES (9,'Dani','/home/httpd/html/images/front/dani.jpg','','Main Clubs Students');
INSERT INTO images VALUES (10,'Daniels','/home/httpd/html/images/front/daniels.jpg','','Main');
INSERT INTO images VALUES (11,'Kali and Chris','/home/httpd/html/images/front/kalichris.jpg','','Main Clubs Students');
INSERT INTO images VALUES (12,'Kati','/home/httpd/html/images/front/kati.jpg','','Students');
INSERT INTO images VALUES (13,'Mikela','/home/httpd/html/images/front/mikela.jpg','','Main Clubs Students');
INSERT INTO images VALUES (14,'Miller and Keiser','/home/httpd/html/images/front/millerkeiser.jpg','Principle Miller and Mr. Keiser duke it out.','Main Clubs Students Staff');
INSERT INTO images VALUES (15,'Tim','/home/httpd/html/images/front/mumbles.jpg','','Main Clubs Students');
INSERT INTO images VALUES (16,'Office Ladies','/home/httpd/html/images/front/officeladies.jpg','Our office ladies.','Main Clubs Students Staff');
INSERT INTO images VALUES (17,'Mr. Olgard','/home/httpd/html/images/front/olgard.jpg','','Main Clubs Students Staff');
INSERT INTO images VALUES (18,'Ross','/home/httpd/html/images/front/ross.jpg','','Main Clubs Students');

#
# Table structure for table 'news'
#

CREATE TABLE news (
  id int(11) NOT NULL auto_increment,
  username varchar(254) NOT NULL default '',
  subject tinytext NOT NULL,
  lead text NOT NULL,
  content text NOT NULL,
  time bigint(20) NOT NULL default '0',
  type varchar(254) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY id (id)
) TYPE=MyISAM;

#
# Dumping data for table 'news'
#

INSERT INTO news VALUES (11,'admin','Senior Baby Pictures','Senior baby ads will be accepted beginning Monday, January 7, until 3 p.m., Friday, February 1. You may choose one of three sizes, 1/8 page for $35; 1/4 page for $50; or 1/2 page for $65. See the senior newsletter for specific details regarding photographs and word limitations. Call Carol Tadlock, the yearbook advisor, at 465-7040, or email at ctadlck@mead.k12.wa.us with questions.','',1008351992,'main');
INSERT INTO news VALUES (5,'admin','Welcome to the Activities Page!','This is the place where you9ll find current information about most of the activities and clubs at Mead.  Band, choir, debate, drama, FCCLA, and many others will share their current events on this page.','',1007403147,'  clubs');
INSERT INTO news VALUES (9,'gooberguy','Jesse Fayant Places 10th at Nationals','Congratulations to Jesse Fayant in his 10th place finish at the Footlocker national cross country meet. He finished the 5k race in 15:07, extremely fast for the hot, humid weather.','',1008351767,' athletics');
INSERT INTO news VALUES (10,'admin','Superintendent Bill Mester Announces Resignation','At the December 10, 2001 meeting of the Mead School District No. 354 Board of Directors, Dr. Bill Mester announced his resignation from Mead School District.  Dr. Mester will be moving to the west side of the state to join his wife, Fran, who is currently serving as an assistant superintendent in the Monroe School District.  \r\n<br>\r\n<br>Dr. Mester has served the Mead School District for 13 years.  During that time our school district has experienced tremendous growth and exceptional success.  While nearly every building in the district has been built or rebuilt during Dr. Mesters tenure, we are certain that he is most proud of the positive relationships he has built both in and out of the school system.  He has done such an outstanding job for our school district.  Dr. Mester is going to be greatly missed.\r\n<br>\r\n<br>The process to replace Dr. Mester will begin after our winter vacation.  Community forums will be held on Thursday, January 3, at the MHS library, and Monday, January 7, in the atrium at Mt. Spokane High School, to gather information regarding the attributes we desire in our next superintendent.  Both meetings will start at 7:30 p.m.  Times and locations will also be advertised in the Spokesman-Review.  We hope you can attend.\r\n<br>\r\n<br>While we will miss Dr. Mesters leadership tremendously, we look forward to the process of finding our next superintendent.  Please participate in the process.\r\n<br>','',1008351921,'main');
INSERT INTO news VALUES (4,'admin','Choir Concert','The Mead Choir Holiday concert will be on Tuesday, December 18, at 7 p.m., in the Mead Theatre.  \r\n<br>\r\n<br>Home-baked goodies will be sold as a fundraiser before and after this concert.  Food items may not be eaten in the theatre; however, you will be welcome to consume your purchases in the lobby before the concert or to leave items destined for home in their packaging while you enjoy the concert. \r\n<br>','',1007401444,'  clubs');
INSERT INTO news VALUES (6,'admin','Welcome to Mead High on the Web','Welcome to the new Mead High School web site. Check back often to see additional features and great new content.','',1008170207,'main');
INSERT INTO news VALUES (8,'admin','Principal Mick Miller\'s Message','November and December seem to intensify the demands on our students and staff.  Academically, we are well into the second quarter and almost two-thirds of the way through the first semester.  This is a tough time for some students, as they realize they must push hard to earn the grades they desire in their classes.  After winter break, only four weeks remain in the semester.  I greatly appreciate the support and help you give your sons and daughters in their academic work.\r<br>\r<br>Our activities program has been very active.  In mid November our drama department presented The Girl in the Mirror, a drama that dealt with teen suicide.  This difficult, but important, topic was handled with artistic sensitivity and the play was well received.  Fall Camp was held at Camp Pinelow in November.  Over 100 MHS students and ten staff members spent three days and two nights at camp.  Camp participants learn leadership and relationship skills.  I highly recommend all students go to camp, as it is a great way to get to know other students and to explore oneself.  Further, it is a great deal of fun!\r<br>\r<br>I know that I often sound like the cheerleader for Mead High School, an easy role for me to play.  On a daily basis, your kids do such a tremendous job here!  They are truly wonderful young people and it is a pleasure to work with them.  If you have any questions or concerns, please give me a call or email.\r<br>Happy Holidays.\r<br>\r<br>\r<br>\r<br>Mick Miller, Principal\r<br>prmiller@mead.k12.wa.us    465-7010 \r<br>','',1008351091,'main');

#
# Table structure for table 'resources'
#

CREATE TABLE resources (
  id int(11) NOT NULL auto_increment,
  type varchar(255) default NULL,
  name varchar(255) default NULL,
  url varchar(255) default NULL,
  description text,
  average float NOT NULL default '0',
  votes int(11) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY type (type)
) TYPE=MyISAM;

#
# Dumping data for table 'resources'
#

INSERT INTO resources VALUES (1,'search_engine','Study\r\nWeb','http://www.studyweb.com/','Comprehensive searchable categorized\r\nindex with reviews of over 17,000 educational and reference Web\r\nsites.',0,0);
INSERT INTO resources VALUES (3,'search_engine','About.com','http://www.about.com','Extensive network\r\nof sites by subject specialists who write articles, host discussions,\r\npublish free email newsletters and provide personally-reviewed links for\r\neach topic.\r\n',0,0);
INSERT INTO resources VALUES (4,'search_engine','Yahoo!','http://www.yahoo.com','Portal providing a\r\ncategory-based Web directory.',0,0);
INSERT INTO resources VALUES (2,'search_engine','Google','http://www.google.com','Uses text-matching\r\ntechniques to find pages that are both important and relevant to your\r\nsearch.',10,1);
INSERT INTO resources VALUES (5,'search_engine','All\r\nAcademic','http://www.allacademic.com/','Provides free academic searches\r\nof the internet. Authors can index academic work as well. ',9.59,47);
INSERT INTO resources VALUES (6,'search_engine','Digital\r\nLibrarian','http://www.digital-librarian.com/','<i>\"A librarian\'s choice\r\nof the best of the Web\"</i>',6.75,4);
INSERT INTO resources VALUES (7,'search_engine','Direct\r\nHit','http://www.directhit.com/','Ranks search results according to what\r\nother people have selected as the most relevant and popular sites for your\r\nsearch request',10,1);
INSERT INTO resources VALUES (8,'search_engine','Library of\r\nCongress','http://www.loc.gov/','Contains Information on everything from\r\ncurrent Legislation, to American History.',0,0);
INSERT INTO resources VALUES (9,'search_engine','Librarians\' Index to the\r\nInternet','http://www.lii.org/','Librarian selected and annotated index to\r\nthe Internet, updated weekly. ',0,0);
INSERT INTO resources VALUES (10,'search_engine','Open Directory\r\nProject','http://dmoz.org/','The largest, most comprehensive human-edited\r\ndirectory of the Web. It is constructed and maintained by a vast, global\r\narmy of volunteer editors.',10,1);
INSERT INTO resources VALUES (11,'encyclopedia','Britannica','http://www.britannica.com/','Access to\r\nthe full contents of the encyclopedia, as well as news and\r\nlinks.\r\n',7,3);
INSERT INTO resources VALUES (12,'encyclopedia','Encyclopedia.com','http://www.encyclopedia.com','Provides\r\nmore than 17,000 short articles from the Concise Columbia Electronic\r\nEncylopedia, Third Edition.',6,1);
INSERT INTO resources VALUES (13,'encyclopedia','Columbia Encyclopedia,\r\nSixth Edition','http://www.bartleby.com/65/','Complete contents of the\r\nyear 2000 publication of the largest one-volume general encyclopedia\r\navailable. Full-text searchable.\r\n',0,0);
INSERT INTO resources VALUES (14,'encyclopedia','Internet\r\nEncyclopedia','http://clever.net/cam/encyclopedia.html','Beta Test of\r\nEncyclopedia of Information Available on the Internet',0,0);
INSERT INTO resources VALUES (15,'encyclopedia','Information\r\nPlease','http://www.infoplease.com/','Offering millions of useful and\r\ninteresting facts on a wide range of topics online. Also includes a\r\ndictionary and encyclopedia. ',0,0);
INSERT INTO resources VALUES (16,'encyclopedia','Encyclopaedia of the\r\nOrient','http://i-cias.com/e.o/index.htm','With photos and\r\nsound; specializes in North Africa and the Middle East. ',0,0);
INSERT INTO resources VALUES (17,'encyclopedia','Encyclopedia\r\nSmithsonian','http://www.si.edu/resource/faq/','Information about a\r\nvariety of topics, from Smithsonian Institution sources',8,1);

#
# Table structure for table 'user_staff'
#

CREATE TABLE user_staff (
  id int(11) NOT NULL auto_increment,
  username varchar(100) default NULL,
  password varchar(100) default NULL,
  user_lvl int(11) NOT NULL default '0',
  first_name varchar(150) NOT NULL default '',
  last_name varchar(150) NOT NULL default '',
  surname varchar(254) NOT NULL default '',
  homepage varchar(254) NOT NULL default '',
  auth mediumtext NOT NULL,
  Department varchar(254) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table 'user_staff'
#

INSERT INTO user_staff VALUES (1,'admin','pass',50,'','','','none','','');

#
# Table structure for table 'user_student'
#

CREATE TABLE user_student (
  id int(11) NOT NULL auto_increment,
  username varchar(100) default NULL,
  password varchar(100) default NULL,
  user_lvl int(11) NOT NULL default '0',
  first_name varchar(150) NOT NULL default '',
  last_name varchar(150) NOT NULL default '',
  sid int(11) default NULL,
  auth mediumtext NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

