<?php
//*
// admin_schedule_teach_3.php
// Admin Section
// Edit schedule for teacher
// v1.0 April 17,2006
// 041307 support for rooms in schedules (Helmut)
//*

//Check if admin is logged in
session_start();
if(!isset($_SESSION['UserID']) || $_SESSION['UserType'] != "A")
  {
    header ("Location: index.php?action=notauth");
	exit;
}

//Include global functions
include_once "common.php";
//Initiate database functions
include_once "ez_sql.php";
// config
include_once "configuration.php";

$cyear=$_SESSION['CurrentYear'];

//Get teacher id
$teacherid=get_param("teacherid");

//Get action
$action=get_param("action");
//Get list of Terms
$sSQL="SELECT * FROM grade_terms ORDER BY grade_terms_desc";
$termcodes=$db->get_results($sSQL);
//get list of subjects
$sSQL="SELECT * FROM grade_subjects ORDER BY grade_subject_desc ASC";
$subjectcodes=$db->get_results($sSQL);
//Get list of Days
$sSQL="SELECT * FROM tbl_days ORDER BY days_id";
$weekdays=$db->get_results($sSQL);
//Get list of rooms
$sSQL="SELECT * FROM school_rooms ORDER BY school_rooms_id";
$rooms=$db->get_results($sSQL);

if ($action=="edit"){
	//Get schedule id
	$schedid=get_param("schedid");
	//Gather info from db
	$sSQL="SELECT school_years_desc,
grade_terms.grade_terms_desc,
grade_subjects.grade_subject_desc, teacher_schedule_classperiod,
teacher_schedule_id, teacher_schedule_termid, teacher_schedule_subjectid, 
teacher_schedule_days, teacher_schedule_room  FROM
((teacher_schedule INNER JOIN
grade_terms ON teacher_schedule_termid=grade_terms_id) INNER JOIN
grade_subjects ON teacher_schedule_subjectid=grade_subject_id) INNER
JOIN school_years ON teacher_schedule_year=school_years.school_years_id WHERE teacher_schedule_id=$schedid";

	$schedule=$db->get_row($sSQL);
	$term=$schedule->grade_terms_desc;
	$subject=$schedule->grade_subject_desc;
	$period=$schedule->teacher_schedule_classperiod;
	$room=$schedule->teacher_schedule_room;
	//$cyear=$schedule->school_years_desc;
	$sschool=$schedule->school_names_desc;

	$sSQL="SELECT teachers_fname, teachers_lname, teachers_school FROM teachers WHERE teachers_id=$teacherid";
	$teacher=$db->get_row($sSQL);
	$tlname=$teacher->teachers_lname;
	$tfname=$teacher->teachers_fname;
	$tschool=$teacher->teachers_school;
	//Get School
	$sSQL="SELECT school_names_desc FROM school_names WHERE school_names_id=$tschool";
	$sschool=$db->get_var($sSQL);

}else{
	//Get teacher name
	$sSQL="SELECT teachers_fname, teachers_lname, teachers_school FROM teachers WHERE teachers_id=$teacherid";
	$teacher=$db->get_row($sSQL);
	$tlname=$teacher->teachers_lname;
	$tfname=$teacher->teachers_fname;
	$tschool=$teacher->teachers_school;

	//Get Year
	$sSQL="SELECT school_years_desc FROM school_years WHERE school_years_id=$cyear";
	$textyear=$db->get_var($sSQL);
	//Get School
	$sSQL="SELECT school_names_desc FROM school_names WHERE school_names_id=$tschool";
	$sschool=$db->get_var($sSQL);
};

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
<title><?php echo "School Management System";?></title>
<style type="text/css" media="all">@import "student-admin.css";</style>
<link rel="icon" href="favicon.ico" type="image/x-icon"><link rel="shortcut icon" href="favicon.ico" type="image/x-icon">

<script type="text/javascript" language="JavaScript" src="sms.js"></script>
</head>

<body><img src="images/<?php echo _LOGO?>" border="0">

<div id="Header">
<table width="100%">
  <tr>
    <td width="50%" align="left"><font size="2">&nbsp;&nbsp;<?php echo date("l F j, Y"); ?></font></td>
    <td width="50%"><?php echo "Administrator Area";?></td>
  </tr>
</table>
</div>

<div id="Content">
	<h1><?php echo "Teacher Schedule for ";?></h1>
	<br>
	<h2><?php echo $tfname. " " .$tlname ; ?></h2>
	<br>
	<table border="1" cellpadding="0" cellspacing="0" width="100%">
	<form name="attendance" method="POST" 
action="admin_schedule_teach_4.php">
	  <tr class="trform">
	    <td width="35%">&nbsp;<?php echo "School";?></td>
	    <td width="30%">&nbsp;<?php echo "Class Period";?></td>
	    <td width="35%">&nbsp;<?php echo "Day of Week"; ?></td>
	  </tr>
	  <tr class="tblcont">
	    <td width="35%">&nbsp;<?php echo $sschool ; ?></td>
	<td width="30%" class="tdinput"> 
	<input type="text" onChange="capitalizeMe(this)" name="period" 
size="20" <?php if($action=="edit"){echo " 
value=".strip($schedule->teacher_schedule_classperiod);}; ?>>
	</td>
	<td width="35%" class="tdinput">
		  <select name="days">
		<?php //Display days from table
		foreach($weekdays as $weekday){
		?>
		<option value="<?php echo $weekday->days_id; ?>" <?php 
if ($weekday->days_id==$schedule->teacher_schedule_days){echo 
"selected=selected";};?>><?php echo $weekday->days_desc; ?></option> 
<?php }; ?>
		   </select>
	</td>
	</tr>
	  <tr class="trform">
	    <td width="35%">&nbsp;<?php echo "Term";?></td>
	    <td width="30%">&nbsp;<?php echo "Subject";?></td>
	    <td width="35%">&nbsp;<?php echo "Room";?></td>
	  </tr>
	  <tr class="tblcont">
	    <td width="35%" class="tdinput">
		  <select name="term2">
		<?php //Display terms from table
		foreach($termcodes as $termcode){
		?>
		<option value="<?php echo $termcode->grade_terms_id; ?>" <?php 
if ($termcode->grade_terms_id==$schedule->teacher_schedule_termid){echo 
"selected=selected";};?>><?php echo $termcode->grade_terms_desc; ?></option> 
<?php }; ?>
		   </select>
		</td>
		<td width="30%" class="tdinput">
			<select name="subject">
		<?php //Display subjects from table
		foreach($subjectcodes as $subjectcode){
		?>
		<option value="<?php echo $subjectcode->grade_subject_id; ?>" 
<?php 
if($subjectcode->grade_subject_id==$schedule->teacher_schedule_subjectid){echo 
"selected=selected";};?>> <?echo $subjectcode->grade_subject_desc; 
?></option> <?php }; ?> 
		</select>
		</td>
		<!--
		<td width="35%" class="tdinput"><input type="text" name="room" 
size="15" <?php if($action=="edit"){echo " 
value=".strip($schedule->teacher_schedule_room);}; ?>> </td> 
		-->
		<td width="30%" class="tdinput">
			<select name="room">
		<?php //Display rooms from table
		foreach($rooms as $room){
		?>
		<option value="<?php echo $room->school_rooms_id; ?>" 
<?php 
if($room->school_rooms_id==$schedule->teacher_schedule_room){echo 
"selected=selected";};?>> <?echo $room->school_rooms_desc;
?></option> <?php }; ?> 
		</select>
		</td>
	  </tr>
	  <?php
	  if($action=="new"){
	  ?>
	  <?php
	  };
	  ?>


	<table>
	<br>
	<table border="0" cellpadding="0" cellspacing="0" width="100%">
	  <tr>
	    <td width="50%"><a 
href="admin_schedule_teach_1.php?teacherid=<?php 
echo $teacherid; ?>" class="aform"><?php echo "Back to Teacher's 
Schedule";?></a></td>
	    <td width="50%" align="right"><input type="submit" name="submit" value="<?php if($action=="edit"){echo "Update Entry";;}else{echo "Add Entry";;};?>" class="frmbut"></td>
	  </tr>
	  <input type="hidden" name="teacherid" value="<?php echo $teacherid; ?>">
	  <input type="hidden" name="schedid" value="<?php echo $schedid; ?>">
	  <input type="hidden" name="studentid" value="<?php echo $studentid; ?>">
	  <input type="hidden" name="action" value="<?php if($action=="edit"){echo "update";}else{echo "new";};?>">
	</table>
</div>
<?php include "admin_menu.inc.php"; ?>
</body>

</html>
