<?php
//*
// admin_states.php
// Admin Section
// Display and Manage States Table
//*

//Check if admin is logged in
session_start();
if(!isset($_SESSION['UserID']) || $_SESSION['UserType'] != "A")
  {
    header ("Location: index.php?action=notauth");
	exit;
}

//Include global functions
include_once "common.php";
//Initiate database functions
include_once "ez_sql.php";
//Include paging class
include_once "ez_results.php";
// config
include_once "configuration.php";

//Check what we have to do
$action = get_param("action");


if (!strlen($action))
	$action="none";

//Add or Remove School States according to admin choice
switch ($action){
	case "remove":
		$id_to_delete = get_param("id");
		$used_studentbio = $db->get_results("SELECT studentbio_id 
			FROM studentbio WHERE studentbio_homeroom ='$id'");
		$used_config = $db->get_results("SELECT default_state 
			FROM tbl_config 
			WHERE default_state teacher_schedule_room = '$id'");
		// $used_attendance = $db->get_results("SELECT custom_attendance_history_id 
		// 	FROM custom_attendance_history 
		// 	WHERE custom_field_id = '$id'");
		if ($used_studentbio || $used_discipline || $used_attendance) {
			$msgFormErr="Field cannot be removed, it"s used in the system.";;
		} else {
			$sSQL="DELETE FROM school_rooms WHERE school_rooms_id=$id_to_delete";
			$db->query($sSQL);
		};
		break;
	case "add":
		$name=get_param("name");
		//Check for duplicates
		$tot=$db->get_var("SELECT count(*) FROM school_rooms WHERE school_rooms_desc='$name'");
		if($tot>0){
			$msgFormErr="Custom Field is already in the system and can"t be duplicated.";;
		}else{
		$cSQL="INSERT INTO school_rooms (school_rooms_desc) VALUES (".tosql($name, "Text").")"; 
		$db->query($cSQL);
		};
		break;
	case "edit":
		$id =get_param("id");
		$cSQL="SELECT school_rooms_desc FROM school_rooms WHERE school_rooms_id = '$id'";
		$name = $db->get_var($cSQL);
		break;
	case "update":
		$id = get_param("id");
		$name = get_param("name");
		$cSQL="UPDATE school_rooms SET school_rooms_desc = '$name' WHERE school_rooms_id = '$id'";
		$db->query($cSQL);
		break;

};


//Set paging appearence
$ezr->results_open = "<table width=65% cellpadding=2 cellspacing=0 border=1>";
$ezr->results_close = "</table>";
$ezr->results_row = "<tr><td class=paging width=70%>COL2</td><td class=paging width=15% align=center><a href=$PHP_SELF?action=edit&id=COL1 class=aform>&nbsp;" . "Edit"; . "</a></td><td class=paging width=15% align=center><a name=href_remove href=#  onclick=cnfremove(COL1); class=aform>&nbsp;" . "Remove"; . "</a></td></tr>";
$ezr->query_mysql("SELECT * FROM school_rooms ORDER BY school_rooms_id");
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
<title><?php echo "School Management System";?></title>
<style type="text/css" media="all">@import "student-admin.css";</style>
<SCRIPT language="JavaScript">
/* Javascript function to submit form and check if field is empty */
function submitform(fldName)
{
  var f = document.forms[0];
  var t = f.elements[fldName]; 
  if (t.value != "") 
    f.submit();
  else
    alert("<?php echo "You have to enter a value!";?>");
}
/* Javascript function to ask confirmation before removing record */
function cnfremove(id) {
	var answer;	
	answer = window.confirm("<?php echo "Are you sure you want to remove this record ?";?>");
	if (answer == 1) {
		var url;
		url = "admin_rooms?action=remove&id=" + id;
		window.location = url; // other browsers
		href_remove.href = url; // explorer 
	}
	return false;
}

</SCRIPT>
<link rel="icon" href="favicon.ico" type="image/x-icon"><link rel="shortcut icon" href="favicon.ico" type="image/x-icon">

<script type="text/javascript" language="JavaScript" src="sms.js"></script>
</head>

<body><img src="images/<?php echo _LOGO?>" border="0">

<div id="Header">
<table width="100%">
  <tr>
    <td width="50%" align="left"><font size="2">&nbsp;&nbsp;<?php echo date("l F j, Y"); ?></font></td>
    <td width="50%"><?php echo "Administrator Area";?></td>
  </tr>
</table>
</div>

<div id="Content">
	<h1><?php echo "Manage Rooms";?></h1>
	<br>
	<?php
	if ($action != "edit"){
		//Dislay results with paging options
		$ezr->display();
		?>
		<br>
		<form name="manage_rooms" method="post" action="<?echo($PHP_SELF);?>">						
		  <p class="pform"><?php echo "Add New Rooms";?><br>
	      <input type="text" onChange="capitalizeMe(this)" name="name" size="20">&nbsp;<A class="aform" href="javascript: submitform('name')"><?php echo "Add";?></a>
	      <input type="hidden" name="action" value="add">
	      </p>
	    </form>
	<?php
	} else {
	?>
		<br>
		<form name="edit_rooms" method="post" action="<?echo($PHP_SELF);?>">
		  <p class="pform"><?php echo "Update Room";?><br>
	      <input type="text" onChange="capitalizeMe(this)" name="name" size="20" value="<?echo ($name);?>">&nbsp;<A class="aform" href="javascript: submitform('name')"><?php echo "Update";?></a>
	      <input type="hidden" name="action" value="update">
		  <input type="hidden" name="id" value="<?php echo($id);?>">
	      </p>
	    </form>
	<?php
	};
    ?>
	<h3><?php echo $msgFormErr; ?></h3>
	</div>
<?php include "admin_maint_tables_menu.inc.php"; ?>
</body>

</html>
