/*
 * < KURA, This application manages the daily activities of a Teacher and a Student of a School>
 *
 * Copyright (C) 2012 Virtusa Corporation.
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

use `akura`;

/*!40014 SET UNIQUE_CHECKS=0 */;
/*!40014 SET FOREIGN_KEY_CHECKS=0 */;

--
-- Changes for `ACHIEVEMENT`
--
ALTER TABLE `ACHIEVEMENT` 
DROP FOREIGN KEY `fk_ACHIEVEMENTS_STUDENT1`,
DROP FOREIGN KEY `fk_ACHIEVEMENT_CLUB_SOCIETY1`; 

ALTER TABLE `ACHIEVEMENT`
ADD CONSTRAINT `fk_ACHIEVEMENTS_STUDENT1` FOREIGN KEY (`STUDENT_ID`) REFERENCES `STUDENT` (`STUDENT_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_ACHIEVEMENT_CLUB_SOCIETY1` FOREIGN KEY (`CLUB_SOCIETY_ID`) REFERENCES `CLUB_SOCIETY` (`CLUB_SOCIETY_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `CHAPTER`
--
ALTER TABLE `CHAPTER` 
DROP FOREIGN KEY`fk_CHAPTER_GRADE_SUBJECT1`,
DROP FOREIGN KEY`fk_CHAPTER_TERM1`; 

ALTER TABLE `CHAPTER` 
ADD CONSTRAINT `fk_CHAPTER_GRADE_SUBJECT1` FOREIGN KEY (`GRADE_SUBJECT_ID`) REFERENCES `GRADE_SUBJECT` (`GRADE_SUBJECT_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_CHAPTER_TERM1` FOREIGN KEY (`TERM_ID`) REFERENCES `TERM` (`TERM_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `CITY`
--
ALTER TABLE `CITY` 
DROP FOREIGN KEY`fk_CITY_DISTRICT1`; 

ALTER TABLE `CITY` 
ADD CONSTRAINT `fk_CITY_DISTRICT1` FOREIGN KEY (`DISTRICT_ID`) REFERENCES `DISTRICT` (`DISTRICT_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `CLASS_GRADE`
--
ALTER TABLE `CLASS_GRADE` 
DROP FOREIGN KEY `fk_CLASS_GRADE_CLASS`,
DROP FOREIGN KEY `fk_CLASS_GRADE_GRADE1`; 

ALTER TABLE `CLASS_GRADE` 
ADD CONSTRAINT `fk_CLASS_GRADE_CLASS` FOREIGN KEY (`CLASS_ID`) REFERENCES `CLASS` (`CLASS_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_CLASS_GRADE_GRADE1` FOREIGN KEY (`GRADE_ID`) REFERENCES `GRADE` (`GRADE_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `CLASS_TEACHER`
--
ALTER TABLE `CLASS_TEACHER` 
DROP FOREIGN KEY `fk_CLASS_GRADE_STAFF_CLASS_GRADE1`; 

ALTER TABLE `CLASS_TEACHER` 
ADD CONSTRAINT `fk_CLASS_GRADE_STAFF_CLASS_GRADE1` FOREIGN KEY (`CLASS_GRADE_ID`) REFERENCES `CLASS_GRADE` (`CLASS_GRADE_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `STUDENT_DISCIPLINE`
--
ALTER TABLE `STUDENT_DISCIPLINE` 
DROP FOREIGN KEY `fk_STUDENT_DESCIPLINE_WARNING_LEVEL1`; 

ALTER TABLE `STUDENT_DISCIPLINE` 
ADD CONSTRAINT `fk_STUDENT_DESCIPLINE_WARNING_LEVEL1` FOREIGN KEY (`WARNING_LEVEL_ID`) REFERENCES `WARNING_LEVEL` (`WARNING_LEVEL_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `DISTRICT`
--
ALTER TABLE `DISTRICT` 
DROP FOREIGN KEY `fk_DISTRICT_PROVINCE1`; 

ALTER TABLE `DISTRICT` 
ADD CONSTRAINT `fk_DISTRICT_PROVINCE1` FOREIGN KEY (`PROVINCE_ID`) REFERENCES `PROVINCE` (`PROVINCE_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `GRADE_SUBJECT`
--
ALTER TABLE `GRADE_SUBJECT` 
DROP FOREIGN KEY `fk_GRADE_SUBJECT_GRADE1`,
DROP FOREIGN KEY `fk_GRADE_SUBJECT_SUBJECT1`; 

ALTER TABLE `GRADE_SUBJECT` 
ADD CONSTRAINT `fk_GRADE_SUBJECT_GRADE1` FOREIGN KEY (`GRADE_ID`) REFERENCES `GRADE` (`GRADE_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_GRADE_SUBJECT_SUBJECT1` FOREIGN KEY (`SUBJECT_ID`) REFERENCES `SUBJECT` (`SUBJECT_ID`) ON DELETE RESTRICT ON UPDATE CASCADE; 

--
-- Changes for `JOB`
--
ALTER TABLE `JOB` 
DROP FOREIGN KEY `fk_JOBS_JOB_TYPE1`; 

ALTER TABLE `JOB` 
ADD CONSTRAINT `fk_JOBS_JOB_TYPE1` FOREIGN KEY (`JOB_TYPE_ID`) REFERENCES `JOB_TYPE` (`JOB_TYPE_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `MASTER_IN_CHARGE`
--
ALTER TABLE `MASTER_IN_CHARGE` 
DROP FOREIGN KEY `fk_master_in_charge_club_society1`,
DROP FOREIGN KEY `fk_MASTER_IN_CHARGE_SPORT_CATEGORY1`,
DROP FOREIGN KEY `fk_MASTER_IN_CHARGE_HOUSE1`;

ALTER TABLE `MASTER_IN_CHARGE` 
ADD CONSTRAINT `fk_MASTER_IN_CHARGE_CLUB_SOCIETY1` FOREIGN KEY (`CLUB_SOCIETY_ID`) REFERENCES `CLUB_SOCIETY` (`CLUB_SOCIETY_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_MASTER_IN_CHARGE_SPORT_CATEGORY1` FOREIGN KEY (`SPORT_CATEGORY_ID`) REFERENCES `SPORT_CATEGORY` (`SPORT_CATEGORY_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_MASTER_IN_CHARGE_HOUSE1` FOREIGN KEY (`HOUSE_ID`) REFERENCES `HOUSE` (`HOUSE_ID`) ON UPDATE CASCADE ON DELETE RESTRICT;

--
-- Changes for `PARENT`
--
ALTER TABLE `PARENT` 
DROP FOREIGN KEY `fk_PARENT_CITY1`,
DROP FOREIGN KEY `fk_PARENT_STAFF1`,
DROP FOREIGN KEY `fk_PARENT_RELIGION1`,
DROP FOREIGN KEY `fk_TEMP_CITY_ID`,
DROP FOREIGN KEY `fk_OFFICE_CITY_ID`,
DROP FOREIGN KEY `fk_PARENT_WORKING_SEGMENT1`;

ALTER TABLE `PARENT` 
ADD CONSTRAINT `fk_PARENT_CITY1` FOREIGN KEY (`CITY_ID`) REFERENCES `CITY` (`CITY_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_PARENT_STAFF1` FOREIGN KEY (`TEACHER_REG_NO`) REFERENCES `STAFF` (`REGISTRATION_NO`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_PARENT_RELIGION1` FOREIGN KEY (`RELIGION_ID`) REFERENCES `RELIGION` (`RELIGION_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_TEMP_CITY_ID` FOREIGN KEY (`TEMP_CITY_ID`) REFERENCES `CITY` (`CITY_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_OFFICE_CITY_ID` FOREIGN KEY (`OFFICE_CITY_ID`) REFERENCES `CITY` (`CITY_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_PARENT_WORKING_SEGMENT1` FOREIGN KEY (`WORKING_SEGMENT_ID`) REFERENCES `WORKING_SEGMENT` (`WORKING_SEGMENT_ID`) ON UPDATE CASCADE ON DELETE RESTRICT;

--
-- Changes for `PARENT_DONATION`
--
ALTER TABLE `PARENT_DONATION` 
DROP FOREIGN KEY `fk_PARENT_DONATION_PARENT1`; 

ALTER TABLE `PARENT_DONATION` 
ADD CONSTRAINT `fk_PARENT_DONATION_PARENT1` FOREIGN KEY (`PARENT_ID`) REFERENCES `PARENT` (`PARENT_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `SCHOOL`
--
ALTER TABLE `SCHOOL` 
DROP FOREIGN KEY `fk_SCHOOL_DISTRICT1`,
DROP FOREIGN KEY `fk_SCHOOL_PROVINCE1`,
DROP FOREIGN KEY `fk_PRINCIPAL`,
DROP FOREIGN KEY `fk_VICE_PRINCIPAL`; 

ALTER TABLE `SCHOOL` 
ADD CONSTRAINT `fk_SCHOOL_DISTRICT1` FOREIGN KEY (`DISTRICT_ID`) REFERENCES `DISTRICT` (`DISTRICT_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_SCHOOL_PROVINCE1` FOREIGN KEY (`PROVINCE_ID`) REFERENCES `PROVINCE` (`PROVINCE_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_PRINCIPAL` FOREIGN KEY (`PRINCIPAL`) REFERENCES `STAFF` (`STAFF_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_VICE_PRINCIPAL` FOREIGN KEY (`VICE_PRINCIPAL`) REFERENCES `STAFF` (`STAFF_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 
 
--
-- Changes for `DONATION`
--
ALTER TABLE `DONATION` 
DROP FOREIGN KEY `fk_DONATION_DONATION_TYPE1`; 

ALTER TABLE `DONATION` 
ADD CONSTRAINT `fk_DONATION_DONATION_TYPE1` FOREIGN KEY (`DONATION_TYPE_ID`) REFERENCES `DONATION_TYPE` (`DONATION_TYPE_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `SPORT_CATEGORY`
--
ALTER TABLE `SPORT_CATEGORY` 
DROP FOREIGN KEY `fk_SPORT_has_SPORT_SUB_SPORT1`,
DROP FOREIGN KEY `fk_SPORT_has_SPORT_SUB_SPORT_SUB1`; 

ALTER TABLE `SPORT_CATEGORY` 
ADD CONSTRAINT `fk_SPORT_has_SPORT_SUB_SPORT1` FOREIGN KEY (`SPORT_ID`) REFERENCES `SPORT` (`SPORT_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_SPORT_has_SPORT_SUB_SPORT_SUB1` FOREIGN KEY (`SPORT_SUB_ID`) REFERENCES `SPORT_SUB` (`SPORT_SUB_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `STAFF`
--
ALTER TABLE `STAFF` 
DROP FOREIGN KEY `fk_STAFF_CITY1`,
DROP FOREIGN KEY `fk_STAFF_STAFF_CATEGORY1`,
DROP FOREIGN KEY `fk_STAFF_RELIGION1`,
DROP FOREIGN KEY `fk_STAFF_TEMP_CITY_ID`; 

ALTER TABLE `STAFF` 
ADD CONSTRAINT `fk_STAFF_CITY1` FOREIGN KEY (`CITY_ID`) REFERENCES `CITY` (`CITY_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_STAFF_STAFF_CATEGORY1` FOREIGN KEY (`STAFF_CATEGORY_ID`) REFERENCES `STAFF_CATEGORY` (`STAFF_CATEGORY_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_STAFF_RELIGION1` FOREIGN KEY (`RELIGION_ID`) REFERENCES `RELIGION` (`RELIGION_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_STAFF_TEMP_CITY_ID` FOREIGN KEY (`TEMP_CITY_ID`) REFERENCES `CITY` (`CITY_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `STAFF_EDUCATIONAL`
--
ALTER TABLE `STAFF_EDUCATIONAL` 
DROP FOREIGN KEY `fk_STAFF_EDUCATIONAL_QUALIFICATION_EDUCATIONAL_QUALIFICATION1`;

ALTER TABLE `STAFF_EDUCATIONAL` 
ADD CONSTRAINT `fk_STAFF_EDUCATIONAL_QUALIFICATION_EDUCATIONAL_QUALIFICATION1` FOREIGN KEY (`EDUCATIONAL_QUAL_ID`) REFERENCES `EDUCATIONAL_QUALIFICATION` (`EDUCATIONAL_QUAL_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `STAFF_PROFESSIONAL`
--
ALTER TABLE `STAFF_PROFESSIONAL` 
DROP FOREIGN KEY `fk_STAFF_PROFESSIONAL_QUALIFICATION_PROFESSIONAL_QUALIFICATION1`; 

ALTER TABLE `STAFF_PROFESSIONAL` 
ADD CONSTRAINT `fk_STAFF_PROFESSIONAL_QUALIFICATION_PROFESSIONAL_QUALIFICATION1` FOREIGN KEY (`PROFESSIONAL_QUAL_ID`) REFERENCES `PROFESSIONAL_QUALIFICATION` (`PROFESSIONAL_QUAL_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `STUDENT`
--
ALTER TABLE `STUDENT` 
DROP FOREIGN KEY `fk_STUDENT_BLOOD_GROUP1`,
DROP FOREIGN KEY `fk_STUDENT_CITY1`,
DROP FOREIGN KEY `fk_STUDENT_HOUSE1`,
DROP FOREIGN KEY `fk_STUDENT_METHOD_OF_TRAVEL1`,
DROP FOREIGN KEY `fk_STUDENT_NATIONALITY1`,
DROP FOREIGN KEY `fk_STUDENT_RELIGION1`,
DROP FOREIGN KEY `fk_STUDENT_LANGUAGE1`,
DROP FOREIGN KEY `fk_TEMPORARY_CITY_ID`,
DROP FOREIGN KEY `fk_PREVIOUS_SCHOOL_STUDY_MEDIUM_ID`; 

ALTER TABLE `STUDENT` 
ADD CONSTRAINT `fk_STUDENT_BLOOD_GROUP1` FOREIGN KEY (`BLOOD_GROUP_ID`) REFERENCES `BLOOD_GROUP` (`BLOOD_GROUP_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_STUDENT_CITY1` FOREIGN KEY (`CITY_ID`) REFERENCES `CITY` (`CITY_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_STUDENT_HOUSE1` FOREIGN KEY (`HOUSE_ID`) REFERENCES `HOUSE` (`HOUSE_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_STUDENT_METHOD_OF_TRAVEL1` FOREIGN KEY (`TRAVEL_ID`) REFERENCES `METHOD_OF_TRAVEL` (`TRAVEL_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_STUDENT_NATIONALITY1` FOREIGN KEY (`NATIONALITY_ID`) REFERENCES `NATIONALITY` (`NATIONALITY_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_STUDENT_RELIGION1` FOREIGN KEY (`RELIGION_ID`) REFERENCES `RELIGION` (`RELIGION_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_STUDENT_LANGUAGE1` FOREIGN KEY (`LANGUAGE_ID`) REFERENCES `LANGUAGE` (`LANGUAGE_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_TEMPORARY_CITY_ID` FOREIGN KEY (`TEMPORARY_CITY_ID`) REFERENCES `CITY` (`CITY_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_PREVIOUS_SCHOOL_STUDY_MEDIUM_ID` FOREIGN KEY (`PREVIOUS_SCHOOL_STUDY_MEDIUM_ID`) REFERENCES `LANGUAGE` (`LANGUAGE_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `STUDENT_CLASS_INFO`
--
ALTER TABLE `STUDENT_CLASS_INFO` 
DROP FOREIGN KEY `fk_STUDENT_CLASS_GRADE_STUDENT1`; 

ALTER TABLE `STUDENT_CLASS_INFO` 
ADD CONSTRAINT `fk_STUDENT_CLASS_GRADE_STUDENT1` FOREIGN KEY (`STUDENT_ID`) REFERENCES `STUDENT` (`STUDENT_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `STUDENT_CLUB_SOCIETY`
--
ALTER TABLE `STUDENT_CLUB_SOCIETY` 
DROP FOREIGN KEY `fk_STUDENT_CLUB_SOCIETIES_CLUB_SOCIETIES1`,
DROP FOREIGN KEY `fk_STUDENT_CLUB_SOCIETIES_POSITION1`,
DROP FOREIGN KEY `fk_STUDENT_CLUB_SOCIETIES_STUDENT1`; 

ALTER TABLE `STUDENT_CLUB_SOCIETY` 
ADD CONSTRAINT `fk_STUDENT_CLUB_SOCIETIES_CLUB_SOCIETIES1` FOREIGN KEY (`CLUB_SOCIETY_ID`) REFERENCES `CLUB_SOCIETY` (`CLUB_SOCIETY_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_STUDENT_CLUB_SOCIETIES_POSITION1` FOREIGN KEY (`POSITION_ID`) REFERENCES `POSITION` (`POSITION_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_STUDENT_CLUB_SOCIETIES_STUDENT1` FOREIGN KEY (`STUDENT_ID`) REFERENCES `STUDENT` (`STUDENT_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `STUDENT_PARENT`
--
ALTER TABLE `STUDENT_PARENT` 
DROP FOREIGN KEY `fk_STUDENT_PARENT_PARENT1`; 
 
ALTER TABLE `STUDENT_PARENT` 
ADD CONSTRAINT `fk_STUDENT_PARENT_PARENT1` FOREIGN KEY (`PARENT_ID`) REFERENCES `PARENT` (`PARENT_ID`) ON UPDATE CASCADE ON DELETE RESTRICT;
--
-- Changes for `STUDENT_SUB_TERM_MARK`
--
ALTER TABLE `STUDENT_SUB_TERM_MARK` 
DROP FOREIGN KEY `fk_STUDENT_SUB_TERM_MARK_GRADING1`,
DROP FOREIGN KEY `fk_STUDENT_SUB_TERM_MARK_SUB_TERM1`; 

ALTER TABLE `STUDENT_SUB_TERM_MARK` 
ADD CONSTRAINT `fk_STUDENT_SUB_TERM_MARK_GRADING1` FOREIGN KEY (`GRADING_ID`) REFERENCES `GRADING` (`GRADING_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_STUDENT_SUB_TERM_MARK_SUB_TERM1` FOREIGN KEY (`SUB_TERM_ID`) REFERENCES `SUB_TERM` (`SUB_TERM_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `STUDENT_PREFECT`
--
ALTER TABLE `STUDENT_PREFECT` 
DROP FOREIGN KEY `fk_STUDENT_PREFECT_TYPE_PREFECT_TYPE1`; 

ALTER TABLE `STUDENT_PREFECT` 
ADD CONSTRAINT `fk_STUDENT_PREFECT_TYPE_PREFECT_TYPE1` FOREIGN KEY (`PREFECT_TYPE_ID`) REFERENCES `PREFECT_TYPE` (`PREFECT_TYPE_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `STUDENT_SCHOLARSHIP`
--
ALTER TABLE `STUDENT_SCHOLARSHIP` 
DROP FOREIGN KEY `fk_STUDENT_SCHOLARSHIP_SCHOLARSHIP1`; 

ALTER TABLE `STUDENT_SCHOLARSHIP` 
ADD CONSTRAINT `fk_STUDENT_SCHOLARSHIP_SCHOLARSHIP1` FOREIGN KEY (`SCHOLARSHIP_ID`) REFERENCES `SCHOLARSHIP` (`SCHOLARSHIP_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `STUDENT_SPORT`
--
ALTER TABLE `STUDENT_SPORT` 
DROP FOREIGN KEY `fk_STUDENT_SPORT_POSITION1`,
DROP FOREIGN KEY `fk_STUDENT_SPORT_SPORT_CATEGORY1`; 

ALTER TABLE `STUDENT_SPORT` 
ADD CONSTRAINT `fk_STUDENT_SPORT_POSITION1` FOREIGN KEY (`POSITION_ID`) REFERENCES `POSITION` (`POSITION_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_STUDENT_SPORT_SPORT_CATEGORY1` FOREIGN KEY (`SPORT_CATEGORY_ID`) REFERENCES `SPORT_CATEGORY` (`SPORT_CATEGORY_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `STUDENT_TERM_MARK`
--
ALTER TABLE `STUDENT_TERM_MARK` 
DROP FOREIGN KEY `fk_STUDENT_CLASS_INFO_GRADE_SUBJECT_GRADE_SUBJECT1`,
DROP FOREIGN KEY `fk_STUDENT_CLASS_INFO_GRADE_SUBJECT_STUDENT_CLASS_INFO1`,
DROP FOREIGN KEY `fk_STUDENT_TERM_MARKS_MERIT_AWARDS1`,
DROP FOREIGN KEY `fk_STUDENT_TERM_MARKS_TERM1`; 

ALTER TABLE `STUDENT_TERM_MARK` 
ADD CONSTRAINT `fk_STUDENT_CLASS_INFO_GRADE_SUBJECT_GRADE_SUBJECT1` FOREIGN KEY (`GRADE_SUBJECT_ID`) REFERENCES `GRADE_SUBJECT` (`GRADE_SUBJECT_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_STUDENT_CLASS_INFO_GRADE_SUBJECT_STUDENT_CLASS_INFO1` FOREIGN KEY (`STUDENT_CLASS_INFO_ID`) REFERENCES `STUDENT_CLASS_INFO` (`STUDENT_CLASS_INFO_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_STUDENT_TERM_MARKS_MERIT_AWARDS1` FOREIGN KEY (`MERIT_AWARDS_ID`) REFERENCES `MERIT_AWARD` (`MERIT_AWARDS_ID`) ON UPDATE CASCADE ON DELETE RESTRICT,
ADD CONSTRAINT `fk_STUDENT_TERM_MARKS_TERM1` FOREIGN KEY (`TERM_ID`) REFERENCES `TERM` (`TERM_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

--
-- Changes for `USER_LOGIN`
--
ALTER TABLE `USER_LOGIN` 
DROP FOREIGN KEY `fk_USER_LOGIN_USER_ROLE1`; 

ALTER TABLE `USER_LOGIN` 
ADD CONSTRAINT `fk_USER_LOGIN_USER_ROLE1` FOREIGN KEY (`USER_ROLE_ID`) REFERENCES `USER_ROLE` (`USER_ROLE_ID`) ON UPDATE CASCADE ON DELETE RESTRICT; 

/*!40014 SET FOREIGN_KEY_CHECKS=1 */;
/*!40014 SET UNIQUE_CHECKS=1 */;

