﻿/**
 * @license Copyright (c) 2003-2013, CKSource - Frederico Knabben. All rights reserved.
 * For licensing, see LICENSE.html or http://ckeditor.com/license
 */

CKEDITOR.plugins.add( 'smiley', {
	requires: 'dialog',
	lang: 'af,ar,bg,bn,bs,ca,cs,cy,da,de,el,en,en-au,en-ca,en-gb,eo,es,et,eu,fa,fi,fo,fr,fr-ca,gl,gu,he,hi,hr,hu,is,it,ja,ka,km,ko,ku,lt,lv,mk,mn,ms,nb,nl,no,pl,pt,pt-br,ro,ru,si,sk,sl,sq,sr,sr-latn,sv,th,tr,ug,uk,vi,zh,zh-cn', // %REMOVE_LINE_CORE%
	icons: 'smiley', // %REMOVE_LINE_CORE%
	init: function( editor ) {
		editor.config.smiley_path = editor.config.smiley_path || ( this.path + 'images/' );
		editor.addCommand( 'smiley', new CKEDITOR.dialogCommand( 'smiley', {
			allowedContent: 'img[alt,height,!src,title,width]',
			requiredContent: 'img'
		} ) );
		editor.ui.addButton && editor.ui.addButton( 'Smiley', {
			label: editor.lang.smiley.toolbar,
			command: 'smiley',
			toolbar: 'insert,50'
		});
		CKEDITOR.dialog.add( 'smiley', this.path + 'dialogs/smiley.js' );
	}
});

/**
 * The base path used to build the URL for the smiley images. It must end with a slash.
 *
 *		config.smiley_path = 'http://www.example.com/images/smileys/';
 *
 *		config.smiley_path = '/images/smileys/';
 *
 * @cfg {String} [smiley_path=CKEDITOR.basePath + 'plugins/smiley/images/']
 * @member CKEDITOR.config
 */

/**
 * The file names for the smileys to be displayed. These files must be
 * contained inside the URL path defined with the {@link #smiley_path} setting.
 *
 *		// This is actually the default value.
 *		config.smiley_images = [
 *			'regular_smile.gif','sad_smile.gif','wink_smile.gif','teeth_smile.gif','confused_smile.gif','tongue_smile.gif',
 *			'embarrassed_smile.gif','omg_smile.gif','whatchutalkingabout_smile.gif','angry_smile.gif','angel_smile.gif','shades_smile.gif',
 *			'devil_smile.gif','cry_smile.gif','lightbulb.gif','thumbs_down.gif','thumbs_up.gif','heart.gif',
 *			'broken_heart.gif','kiss.gif','envelope.gif'
 *		];
 *
 * @cfg
 * @member CKEDITOR.config
 */
CKEDITOR.config.smiley_images = [
	'Angel.png','Angry.png','Aww.png','Aww_2.png','Blushing.png','Childish.png','Confused.png','Creepy.png','Crying.png','Cthulhu.png',
	'Cute.png','Cute_Winking.png','Devil.png','Gah.png','Gah_2.png','Gasping.png','Greedy.png','Grinning.png','Grinning_Winking.png',
	'Happy.png','Happy_2.png','Happy_3.png','Heart.png','Huh.png','Huh_2.png','Laughing.png','Lips_Sealed.png','Madness.png','Malicious.png',
	'Sick.png','Smiling.png','Speechless.png','Spiteful.png','Stupid.png','Sunglasses.png','Terrified.png','Thumb_Down.png','Thumb_Up.png',
	'Tired.png','Tongue_Out.png','Tongue_Out_Laughing.png','Tongue_Out_Left.png','Tongue_Out_Up.png','Tongue_Out_Up_Left.png','Tongue_Out_Winking.png',
	'Uncertain.png','Uncertain_2.png','Unhappy.png','Winking.png'
];

/**
 * The description to be used for each of the smileys defined in the
 * {@link CKEDITOR.config#smiley_images} setting. Each entry in this array list
 * must match its relative pair in the {@link CKEDITOR.config#smiley_images}
 * setting.
 *
 *		// Default settings.
 *		config.smiley_descriptions = [
 *			'smiley', 'sad', 'wink', 'laugh', 'frown', 'cheeky', 'blush', 'surprise',
 *			'indecision', 'angry', 'angel', 'cool', 'devil', 'crying', 'enlightened', 'no',
 *			'yes', 'heart', 'broken heart', 'kiss', 'mail'
 *		];
 *
 *		// Use textual emoticons as description.
 *		config.smiley_descriptions = [
 *			':)', ':(', ';)', ':D', ':/', ':P', ':*)', ':-o',
 *			':|', '>:(', 'o:)', '8-)', '>:-)', ';(', '', '', '',
 *			'', '', ':-*', ''
 *		];
 *
 * @cfg
 * @member CKEDITOR.config
 */
CKEDITOR.config.smiley_descriptions = [
	'Angel','Angry','Aww','Aww_2','Blushing','Childish','Confused','Creepy','Crying','Cthulhu',
	'Cute','Cute_Winking','Devil','Gah','Gah_2','Gasping','Greedy','Grinning','Grinning_Winking',
	'Happy','Happy_2','Happy_3','Heart','Huh','Huh_2','Laughing','Lips_Sealed','Madness','Malicious',
	'Sick','Smiling','Speechless','Spiteful','Stupid','Sunglasses','Terrified','Thumb_Down','Thumb_Up',
	'Tired','Tongue_Out','Tongue_Out_Laughing','Tongue_Out_Left','Tongue_Out_Up','Tongue_Out_Up_Left','Tongue_Out_Winking',
	'Uncertain','Uncertain_2','Unhappy','Winking'
];

/**
 * The number of columns to be generated by the smilies matrix.
 *
 *		config.smiley_columns = 6;
 *
 * @since 3.3.2
 * @cfg {Number} [smiley_columns=8]
 * @member CKEDITOR.config
 */
