<?php if ( ! defined('BASE_PATH') ) exit('No direct script access allowed');
/**
 * Error View
 *  
 * PHP 5.4+
 *
 * eduTrac(tm) : Student Information System (http://www.7mediaws.org/)
 * @copyright (c) 2013 7 Media Web Solutions, LLC
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * 
 * @license     http://www.gnu.org/licenses/gpl-3.0.html GNU General Public License, version 3
 * @link        http://www.7mediaws.org/
 * @since       3.0.0
 * @package     eduTrac
 * @author      Joshua Parker <josh@7mediaws.org>
 */
use \eduTrac\Classes\Libraries\Hooks;
?>

<!-- Wrapper -->
<div id="login">

	<div class="container">

	<!-- Box -->
	<div class="hero-unit well">
		<h1 class="padding-none"><?=_t('Ouch!');?> <span><?=_t('404 error');?></span></h1>
		<hr class="separator" />
		<!-- Row -->
		<div class="row-fluid">
		
			<!-- Column -->
			<div class="span6">
				<div class="center">
					<p><?=_t('It seems the page you are looking for is not here anymore. The page might have moved to another address or just removed by our staff.');?></p>
				</div>
			</div>
			<!-- // Column END -->
			
			<!-- Column -->
			<div class="span6">
				<div class="center">
					<p><?=_t('Is this a serious error?');?> <a href="<?=Hooks::get_option('help_desk');?>"><?=_t('Let us know');?></a></p>
					<div class="row-fluid">
						<div class="span6">
							<a href="<?=BASE_URL;?>dashboard/" class="btn btn-icon-stacked btn-block btn-success glyphicons user_add"><i></i><span><?=_t('Go back to');?></span><span class="strong"><?=_t('Dashboard');?></span></a>
						</div>
						<div class="span6">
							<a href="<?=Hooks::get_option('help_desk');?>" class="btn btn-icon-stacked btn-block btn-danger glyphicons circle_question_mark"><i></i><span><?=_t('Browse through our');?></span><span class="strong"><?=_t('Support Center');?></span></a>
						</div>
					</div>
				</div>
			</div>
			<!-- // Column END -->
			
		</div>
		<!-- // Row END -->
		
	</div>
	<!-- // Box END -->
	
	</div>
	
</div>
<!-- // Wrapper END -->