<?php
//*
// teacher_manage_attendance_2.php
// Teachers Section
// Display details on attendance record for student
//*

//Check if teacher is logged in
session_start();
if(!isset($_SESSION['UserID']) || $_SESSION['UserType'] != "T")
  {
    header ("Location: index.php?action=notauth");
	exit;
}
$tfname=$_SESSION['tfname'];
$tlname=$_SESSION['tlname'];
$current_year=$_SESSION['CurrentYear'];
$web_user=$_SESSION['UserID'];

//Include global functions
include_once "common.php";
//Initiate database functions
include_once "ez_sql.php";
// Include configuration
include_once "configuration.php";

//Get Studentid
$studentid=get_param("studentid");

//Get attendace id
$attid=get_param("attid");

//Get info
$sSQL="SELECT studentbio.studentbio_lname, studentbio.studentbio_fname,  
school_names.school_names_desc, school_years.school_years_desc,  
DATE_FORMAT(attendance_history.attendance_history_date, '%m/%d/%Y') as attdate,  
attendance_codes.attendance_codes_desc, 
attendance_history.attendance_history_notes, web_users.web_users_flname FROM  
((((studentbio INNER JOIN attendance_history ON studentbio.studentbio_id =  
attendance_history.attendance_history_student) INNER JOIN school_names ON  
attendance_history.attendance_history_school = school_names.school_names_id) INNER 
JOIN school_years ON attendance_history.attendance_history_year = 
school_years.school_years_id) INNER JOIN attendance_codes ON 
attendance_history.attendance_history_code = attendance_codes.attendance_codes_id) 
INNER JOIN web_users ON attendance_history.attendance_history_user = 
web_users.web_users_id WHERE attendance_history_id= $attid";

$attendance=$db->get_row($sSQL);

//get the custom fields associated with this attendance event added by Joshua
$custom_attendance_sql = "SELECT * from custom_attendance_history, custom_fields 
	WHERE (custom_attendance_history.custom_field_id = custom_fields.custom_field_id)
	AND (attendance_history_id = '". $attid ."')";
$custom_attendance_fields = $db->get_results($custom_attendance_sql);
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
<title><?php echo "School Management System";?></title>
<style type="text/css" media="all">@import "student-teacher.css";</style>
<link rel="icon" href="favicon.ico" type="image/x-icon"><link rel="shortcut icon" href="favicon.ico" type="image/x-icon"><script type="text/javascript" language="JavaScript" src="sms.js"></script>
</head>

<body><img src="images/<?php echo _LOGO?>" border="0">

<div id="Header">
<table width="100%">
  <tr>
    <td width="50%" align="left"><font size="2">&nbsp;&nbsp;<?php echo date("l F j, Y"); ?></font></td>
    <td width="50%"><?php echo "Welcome";?>, <?php echo $tfname. " " .$tlname; ?></td>
  </tr>
</table>
</div>
<div id="Content">
	<h1><?php echo "Attendance history for student";?></h1>
	<br>
	<h2><?php echo $attendance->studentbio_fname. " " .$attendance->studentbio_lname; ?></h2>
	<br>
	<h2>Note inserted by <?php echo $attendance->web_users_flname; ?></h2>
	<table border="1" cellpadding="0" cellspacing="0" width="100%">
	  <tr class="tblhead">
	    <td width="50%">&nbsp;<?php echo "School";?></td>
	    <td width="50%">&nbsp;<?php echo "Year";?></td>
	  </tr>
	  <tr class="tblcont">
	    <td width="50%">&nbsp;<?php echo $attendance->school_names_desc ; ?></td>
	    <td width="50%">&nbsp;<?php echo $attendance->school_years_desc ; ?></td>
	  </tr>
	  <tr class="tblhead">
	    <td width="50%">&nbsp;<?php echo "Code";?></td>
	    <td width="50%">&nbsp;<?php echo "Date";?></td>
	  </tr>
	  <tr class="tblcont">
	    <td width="50%">&nbsp;<?php echo $attendance->attendance_codes_desc ; ?></td>
		<td width="50%">&nbsp;<?php echo $attendance->attdate ; ?></td>
	  </tr>
	  <tr class="tblhead">
	    <td width="100%" colspan="2">&nbsp;<?php echo "Notes";?></td>
	  </tr>
	  <tr class="tblcont">
	    <td width="100%" colspan="2">&nbsp;<?php echo $attendance->attendance_history_notes ; ?></td>
	  </tr>
	
	<?php //display custom fields added by Joshua
     if(count($custom_attendance_fields)) {
		?><tr><td colspan=2><h2>Custom Fields</h2></td></tr>
		<tr><td colspan=2><table width="100%"><?php
     	foreach($custom_attendance_fields as $custom_attendance_field) {
  			?><tr><td class="tblhead"><?php
  			echo($custom_attendance_field->name);
  			?>:</td><td class="tblcont"><?php
			echo($custom_attendance_field->data);
     	    	?></td></tr><?php
     	 }
		 ?></table></td></tr><?php
	} 
	//end of custom fields
	?>

	<table>
	<br>
	<table border="0" cellpadding="0" cellspacing="0" width="100%">
	  <tr>
	    <td width="50%"><a href="teacher_edit_student_1.php?studentid=<?php echo $studentid; ?>" class="aform"><?php echo "Back to Student";?></a></td>
	    <td width="50%" align="right"><a href="teacher_manage_attendance_3.php?studentid=<?php echo $studentid; ?>&attid=<?php echo $attid; ?>&action=edit" class="aform"><?php echo "Edit Attendance Note";?></a></td>
	  </tr>
	</table>
</div>
<?php include "teacher_menu.inc.php"; ?>
</body>

</html>
